Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.hpp	(revision 1984)
@@ -227,6 +227,5 @@
 
         bool hasGridMask(void) const;
-        CGrid* getGrid(void) { return grid_; } 
-
+        
         void connectToFileServer(CGarbageCollector& gc) ;
         void connectToCouplerOut(CGarbageCollector& gc) ;
@@ -268,4 +267,12 @@
 
          CGrid*  grid_=nullptr;
+         CGrid* getGrid(void) { return grid_; } 
+      
+      private:
+         CGrid* sentGrid_=nullptr ;
+      public:
+         CGrid* getSentGrid(void) { return sentGrid_; }    
+
+      public:
 //         CFile*  file;
          
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/generate_rectilinear_domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/generate_rectilinear_domain.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/generate_rectilinear_domain.cpp	(revision 1984)
@@ -27,5 +27,5 @@
   bool CGenerateRectilinearDomain::registerTrans()
   {
-    registerTransformation(TRANS_GENERATE_RECTILINEAR_DOMAIN, create);
+    registerTransformation(TRANS_GENERATE_RECTILINEAR_DOMAIN, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/generate_rectilinear_domain.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/generate_rectilinear_domain.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/generate_rectilinear_domain.hpp	(revision 1984)
@@ -41,4 +41,6 @@
       typedef CObjectTemplate<CGenerateRectilinearDomain> SuperClass;
       typedef CGenerateRectilinearDomainAttributes SuperClassAttribute;
+      typedef CGenerateRectilinearDomain MyClass ;
+      typedef CTransformation<CDomain> SuperTransform ;
 
     public :
@@ -56,4 +58,8 @@
       static StdString GetDefName(void);
       static ENodeType GetType(void);
+      const string& getId(void) { return this->SuperClass::getId();}
+      ETranformationType getTransformationType(void) { return TRANS_GENERATE_RECTILINEAR_DOMAIN ;}
+      static CTransformation<CDomain>* getTransformation(const StdString& id) { return SuperClass::get(id);}
+      virtual void inheritFrom(SuperTransform* srcTransform) { solveDescInheritance(true, this->SuperClass::get((MyClass*)srcTransform)) ;}
     private:
       static bool registerTrans();
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.cpp	(revision 1984)
@@ -24,7 +24,11 @@
 #include "grid_local_view.hpp"
 #include "grid_mask_connector.hpp"
-
-
-namespace xios {
+#include "transformation_path.hpp"
+#include "grid_transformation_factory_impl.hpp"
+#include "transform_filter.hpp"
+
+
+namespace xios
+{
 
    /// ////////////////////// Dfinitions ////////////////////// ///
@@ -236,5 +240,7 @@
      axis_domain_order.resize(order_.size());
      for (int idx = 0; idx < order_.size(); ++idx) axis_domain_order(idx)=order_[idx];
-     return vDomainGroup_->createChild(id);
+     CDomain* domain = vDomainGroup_->createChild(id);
+     computeElements();
+     return domain ;
    }
    CATCH_DUMP_ATTR
@@ -246,5 +252,7 @@
      axis_domain_order.resize(order_.size());
      for (int idx = 0; idx < order_.size(); ++idx) axis_domain_order(idx)=order_[idx];
-     return vAxisGroup_->createChild(id);
+     CAxis* axis=vAxisGroup_->createChild(id);
+     computeElements(); 
+     return axis ;
    }
    CATCH_DUMP_ATTR
@@ -256,5 +264,7 @@
      axis_domain_order.resize(order_.size());
      for (int idx = 0; idx < order_.size(); ++idx) axis_domain_order(idx)=order_[idx];
-     return vScalarGroup_->createChild(id);
+     CScalar* scalar =  vScalarGroup_->createChild(id);
+     computeElements();
+     return scalar;
    }
    CATCH_DUMP_ATTR
@@ -518,4 +528,5 @@
     int idxDomain = 0, idxAxis=0 , idxScalar=0 ; 
  
+    elements_.clear() ;
     for(auto type : order_)
     {
@@ -572,4 +583,5 @@
     setAxisList();
     setScalarList();
+    computeElements() ;
    }
    CATCH_DUMP_ATTR
@@ -960,6 +972,4 @@
 
    
-//----------------------------------------------------------------
-
 
 
@@ -1871,9 +1881,4 @@
 
 
-
-
-
-
-
   bool CGrid::hasTransform()
   TRY
@@ -1892,4 +1897,262 @@
   }
   CATCH_DUMP_ATTR
+
+
+
+//**********************************************************
+//**************   New transformation method  **************
+//**********************************************************
+
+  std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > 
+  CGrid::buildTransformationGraph(CGarbageCollector& gc, CGrid* gridSrc, double detectMissingValues, double defaultValue, CGrid*& newGrid)
+  TRY
+  {
+    std::shared_ptr<CFilter> inputFilter = std::shared_ptr<CPassThroughFilter>(new CPassThroughFilter(gc));
+    std::shared_ptr<CFilter> outputFilter = inputFilter ;
+    
+    newGrid = CGrid::create() ; // give it an id later ??
+    bool hadTransform=false ;
+    bool hasTransform=false ;
+    CGenericAlgorithmTransformation* algo ;
+    int dimBefore=1 ;
+    int dimAfter=1 ;
+
+    for(int i=0 ; i<elements_.size(); i++)
+    {
+      CTransformationPaths transformationPath ;
+      auto dstElement = elements_[i] ;
+
+      if (dstElement.type==TYPE_DOMAIN)      transformationPath = dstElement.domain->getTransformationPaths() ;
+      else if (dstElement.type==TYPE_AXIS)   transformationPath = dstElement.axis->getTransformationPaths() ;
+      else if (dstElement.type==TYPE_SCALAR) transformationPath = dstElement.scalar->getTransformationPaths() ;
+
+      SElement srcElement  ;
+      if (gridSrc==nullptr) srcElement = this->elements_[i] ;
+      else srcElement = gridSrc->elements_[i] ;
+
+      if (gridSrc==nullptr) transformationPath.mergePaths() ;
+      else
+      {  
+        if (srcElement.type==TYPE_DOMAIN)      transformationPath.mergePaths(srcElement.domain->getTransformationPaths()) ;
+        else if (srcElement.type==TYPE_AXIS)   transformationPath.mergePaths(srcElement.axis->getTransformationPaths()) ;
+        else if (srcElement.type==TYPE_SCALAR) transformationPath.mergePaths(srcElement.scalar->getTransformationPaths()) ;
+      }
+
+      hasTransform=transformationPath.hasTransform()  ;
+      
+
+      if (hasTransform && !hadTransform)
+      {
+        EElement dstElementType=transformationPath.getNextElementType() ;
+        string dstElementId=transformationPath.getNextElementId() ;
+        string srcElementId=transformationPath.getNextElementSrcId() ;
+        auto transType = transformationPath.getNextTransformationType() ;
+        auto transId = transformationPath.getNextTransformationId() ;
+
+        CGrid* tmpGridSrc=CGrid::create(); // source grid 
+        if (srcElement.type==TYPE_DOMAIN)      tmpGridSrc->addDomain(srcElement.domain->getId()) ;
+        else if (srcElement.type==TYPE_AXIS)   tmpGridSrc->addAxis(srcElement.axis->getId()) ;
+        else if (srcElement.type==TYPE_SCALAR) tmpGridSrc->addScalar(srcElement.scalar->getId()) ;
+        tmpGridSrc->checkElementsAttributes() ;
+        CGrid* tmpGridDst=CGrid::create(); // destination Grid
+        map<int,int> posInGrid={{0,0}} ;
+               
+        cout<<"--> New transform from "<<srcElementId<<" to "<<dstElementId<<endl ;
+        if (dstElementType==EElement::DOMAIN)
+        {
+          CDomain* dstDomain ;
+          if (CDomain::has(dstElementId)) dstDomain = CDomain::get(dstElementId) ;
+          else
+          {
+            dstDomain = CDomain::create() ;
+            dstDomain->createAlias(dstElementId) ;
+            if (srcElementId=="" && srcElement.type==TYPE_DOMAIN)  dstDomain->duplicateAttributes(srcElement.domain) ; // make a copy
+            else dstDomain->duplicateAttributes(CDomain::get(srcElementId)) ; // make a copy
+            CTransformation<CDomain>* transformation = CTransformation<CDomain>::createTransformation(transType,"") ;
+            auto srcTransform = CTransformation<CDomain>::getTransformation(transType, transId) ;
+            transformation->inheritFrom(srcTransform) ;
+            tmpGridDst->addDomain(dstDomain->getId()) ;
+
+            //reuse existing algorithm interface for, now
+            algo = CGridTransformationFactory<CDomain>::createTransformation(transType, tmpGridDst, tmpGridSrc,
+                                                                             transformation, 0, 
+                                                                             posInGrid,posInGrid,posInGrid,
+                                                                             posInGrid,posInGrid,posInGrid );
+            dstDomain->setTransformationAlgorithm(algo) ;
+            transformationPath.removeNextTransform() ;
+            dstDomain->setTransformationPaths(transformationPath) ;
+            newGrid->addDomain(dstDomain->getId()) ;
+          }
+          algo = dstDomain->getTransformationAlgorithm() ;
+        }
+        else if (dstElementType==EElement::AXIS)
+        {
+          CAxis* dstAxis ;
+          if (CAxis::has(dstElementId)) dstAxis = CAxis::get(dstElementId) ;
+          else
+          {
+            dstAxis = CAxis::create() ;
+            dstAxis->createAlias(dstElementId) ;
+            if (srcElementId=="" && srcElement.type==TYPE_AXIS)  dstAxis->duplicateAttributes(srcElement.axis) ; // make a copy
+            else dstAxis->duplicateAttributes(CAxis::get(srcElementId)) ; // make a copy
+            CTransformation<CAxis>* transformation = CTransformation<CAxis>::createTransformation(transType,"") ;
+            auto srcTransform = CTransformation<CAxis>::getTransformation(transType, transId) ;
+            transformation->inheritFrom(srcTransform) ;
+            tmpGridDst->addAxis(dstAxis->getId()) ;
+
+            //reuse existing algorithm interface for, now
+            algo = CGridTransformationFactory<CAxis>::createTransformation(transType, tmpGridDst, tmpGridSrc,
+                                                                           transformation, 0, 
+                                                                           posInGrid,posInGrid,posInGrid,
+                                                                           posInGrid,posInGrid,posInGrid );
+            dstAxis->setTransformationAlgorithm(algo) ;
+            transformationPath.removeNextTransform() ;
+            dstAxis->setTransformationPaths(transformationPath) ;
+            newGrid->addAxis(dstAxis->getId()) ;
+          }
+          algo = dstAxis->getTransformationAlgorithm() ;
+        }
+        else if (dstElementType==EElement::SCALAR)
+        {
+          CScalar* dstScalar ;
+          if (CScalar::has(dstElementId)) dstScalar = CScalar::get(dstElementId) ;
+          else
+          {
+            dstScalar = CScalar::create() ;
+            dstScalar->createAlias(dstElementId) ;
+            if (srcElementId=="" && srcElement.type==TYPE_SCALAR)  dstScalar->duplicateAttributes(srcElement.scalar) ; // make a copy
+            else dstScalar->duplicateAttributes(CScalar::get(srcElementId)) ; // make a copy
+            CTransformation<CScalar>* transformation = CTransformation<CScalar>::createTransformation(transType,"") ;
+            auto srcTransform = CTransformation<CScalar>::getTransformation(transType, transId) ;
+            transformation->inheritFrom(srcTransform) ;
+            tmpGridDst->addScalar(dstScalar->getId()) ;
+
+            //reuse existing algorithm interface for, now
+            algo = CGridTransformationFactory<CScalar>::createTransformation(transType, tmpGridDst, tmpGridSrc,
+                                                                             transformation, 0, 
+                                                                             posInGrid,posInGrid,posInGrid,
+                                                                             posInGrid,posInGrid,posInGrid );
+            dstScalar->setTransformationAlgorithm(algo) ;
+            transformationPath.removeNextTransform() ;
+            dstScalar->setTransformationPaths(transformationPath) ;
+            newGrid->addScalar(dstScalar->getId()) ;
+          }
+          algo = dstScalar->getTransformationAlgorithm() ;          
+        }
+        // here create a new spatial filter with algo
+        
+        hadTransform=true ;
+        hasTransform=false ; 
+      }
+      else
+      {
+        string srcElementId=transformationPath.getNextElementSrcId() ;
+        if (srcElement.type==TYPE_DOMAIN)      
+        {
+          CDomain* domain ;
+          if (!CDomain::has(srcElementId)) 
+          {
+            domain=srcElement.domain ;
+            domain->createAlias(srcElementId) ;
+          }
+          else domain = CDomain::get(srcElementId) ;
+          domain->checkAttributes() ;
+         
+          if (hadTransform) dimBefore*=domain->getLocalView(CElementView::WORKFLOW)->getLocalSize() ;
+          else dimAfter*=domain->getLocalView(CElementView::WORKFLOW)->getLocalSize() ;
+          newGrid->addDomain(srcElementId) ;
+        }
+        else if (srcElement.type==TYPE_AXIS)
+        {   
+          CAxis* axis ;
+          if (!CAxis::has(srcElementId)) 
+          {
+            axis=srcElement.axis ;
+            axis->createAlias(srcElementId) ;
+          }
+          else axis = CAxis::get(srcElementId) ;
+          axis->checkAttributes() ;
+         
+          if (hadTransform) dimBefore*=axis->getLocalView(CElementView::WORKFLOW)->getLocalSize() ;
+          else dimAfter*=axis->getLocalView(CElementView::WORKFLOW)->getLocalSize() ;
+          newGrid->addAxis(srcElementId) ;
+        }
+        else if (srcElement.type==TYPE_SCALAR)
+        {
+          CScalar* scalar ;
+          if (!CScalar::has(srcElementId)) 
+          {
+            scalar=srcElement.scalar ;
+            scalar->createAlias(srcElementId) ;
+          }
+          else scalar = CScalar::get(srcElementId) ;
+          scalar->checkAttributes() ;
+         
+          if (hadTransform) dimBefore*=scalar->getLocalView(CElementView::WORKFLOW)->getLocalSize() ;
+          else dimAfter*=scalar->getLocalView(CElementView::WORKFLOW)->getLocalSize() ;
+          newGrid->addScalar(srcElementId) ;
+        }
+      }
+    }  
+    
+    if (hadTransform)
+    {
+      shared_ptr<CTransformFilter> transformFilter = shared_ptr<CTransformFilter>(new CTransformFilter(gc, algo, dimBefore, dimAfter, detectMissingValues, defaultValue)) ;
+      outputFilter->connectOutput(transformFilter,0) ;
+      outputFilter = transformFilter ;
+
+      gridSrc=newGrid ;
+      pair<shared_ptr<CFilter>, shared_ptr<CFilter> > filters = gridSrc->buildTransformationGraph(gc, gridSrc, detectMissingValues, defaultValue, newGrid) ;
+      outputFilter->connectOutput(filters.first,0) ;
+      outputFilter=filters.second ;
+    }
+     
+    return {inputFilter,outputFilter} ;
+  }
+  CATCH_DUMP_ATTR
+
+
+//****************************************************************
+//****************************************************************
+
+//----------------------------------------------------------------
+
+  CGrid* CGrid::duplicateSentGrid(void)
+  {
+    CGrid* newGrid ;
+    string sentGridId="sent__"+getId() ;
+    if (has(sentGridId)) newGrid = get(sentGridId) ;
+    else
+    {
+      newGrid = CGrid::create(sentGridId) ;
+      for(auto element : elements_)
+      {
+        if (element.type==TYPE_DOMAIN)      
+        {
+          CDomain* domain = CDomain::create();
+          domain->duplicateAttributes(element.domain) ;
+          domain->name = element.domain->getId() ;
+          newGrid->addDomain(domain->getId()) ;
+        }
+        else if (element.type==TYPE_AXIS)      
+        {
+          CAxis* axis = CAxis::create();
+          axis->duplicateAttributes(element.axis) ;
+          axis->name = element.axis->getId() ;
+          newGrid->addAxis(axis->getId()) ;
+        }
+        else if (element.type==TYPE_SCALAR)      
+        {
+          CScalar* scalar = CScalar::create();
+          scalar->duplicateAttributes(element.scalar) ;
+          scalar->name = element.scalar->getId() ;
+          newGrid->addScalar(scalar->getId()) ;
+        }
+      }
+      newGrid->checkElementsAttributes() ;
+    }
+    return newGrid ;
+  }
+
 
   void CGrid::setContextClient(CContextClient* contextClient)
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/grid.hpp	(revision 1984)
@@ -20,4 +20,6 @@
 #include "grid_scatterer_connector.hpp"
 #include "grid_gatherer_connector.hpp"
+#include "transformation_path.hpp"
+#include "filter.hpp"
 
 
@@ -210,4 +212,8 @@
          bool doGridHaveDataDistributed(CContextClient* client = 0);
 
+         ///////////////////////////////////////////
+         ////////    TRANSFORMATIONS           /////
+         ///////////////////////////////////////////
+      public:
          CGridTransformation* getTransformations();
 
@@ -221,5 +227,7 @@
          
          std::vector<std::string> getAuxInputTransformGrid(void) ; 
-
+         std::map<CGrid*, std::pair<bool,StdString> >& getTransGridSource();
+         bool hasTransform();
+         void addTransGridSource(CGrid* gridSrc);
          void completeGrid(CGrid* transformGridSrc = 0);
          bool isTransformed();
@@ -227,8 +235,16 @@
          bool isGenerated();
          void setGenerated();
-         void addTransGridSource(CGrid* gridSrc);
-         std::map<CGrid*, std::pair<bool,StdString> >& getTransGridSource();
-         bool hasTransform();
-         size_t getGlobalWrittenSize(void) ;
+         void setTransformationAlgorithms();
+         pair<shared_ptr<CFilter>, shared_ptr<CFilter> > buildTransformationGraph(CGarbageCollector& gc, CGrid* gridSrc, double detectMissingValues,
+                                                                                  double defaultValue, CGrid*& newGrid) ;
+      private:
+         bool isTransformed_, isGenerated_;
+         CGridTransformation* transformations_;
+         bool hasTransform_;
+       
+        ///////////////////////////////////////////
+      public:
+
+        size_t getGlobalWrittenSize(void) ;
          
          bool isCompleted(void) ;
@@ -265,5 +281,4 @@
         CScalarGroup* getVirtualScalarGroup() const;
 
-        void setTransformationAlgorithms();
         int computeGridGlobalDimension(std::vector<int>& globalDim,
                                        const std::vector<CDomain*> domains,
@@ -310,5 +325,4 @@
         std::set<std::string> relFilesCompressed;
 
-        bool isTransformed_, isGenerated_;
         
         std::vector<int> axisPositionInGrid_;
@@ -317,12 +331,12 @@
         std::vector<int>& getAxisPositionInGrid(void) { if (!computeAxisPositionInGrid_done_) computeAxisPositionInGrid() ; return axisPositionInGrid_ ;}
 
-        CGridTransformation* transformations_;
         bool hasDomainAxisBaseRef_;        
         std::map<CGrid*, std::pair<bool,StdString> > gridSrc_;
-        bool hasTransform_;
 
      //////////////////////////////////////////////////////////////////////////////////////
      //  this part is related to distribution, element definition, views and connectors  //
      //////////////////////////////////////////////////////////////////////////////////////
+      public:
+       CGrid* duplicateSentGrid(void) ;
       private:
        static void recvMask(CEventServer& event) ;
@@ -336,5 +350,5 @@
 
       private:
-        CGridLocalConnector* modelToWorkflowConnector_ ;
+        CGridLocalConnector* modelToWorkflowConnector_ = nullptr ;
       public:
         void computeModelToWorkflowConnector(void) ;
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_axis.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_axis.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_axis.cpp	(revision 1984)
@@ -27,5 +27,5 @@
   bool CInterpolateAxis::registerTrans()
   {
-    return registerTransformation(TRANS_INTERPOLATE_AXIS, CInterpolateAxis::create);
+    return registerTransformation(TRANS_INTERPOLATE_AXIS, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_axis.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_axis.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_axis.hpp	(revision 1984)
@@ -41,4 +41,6 @@
       typedef CObjectTemplate<CInterpolateAxis> SuperClass;
       typedef CInterpolateAxisAttributes SuperClassAttribute;
+      typedef CInterpolateAxis MyClass ;
+      typedef CTransformation<CAxis> SuperTransform ;
 
     public :
@@ -58,4 +60,8 @@
       static StdString GetDefName(void);
       static ENodeType GetType(void);
+      const string& getId(void) { return this->SuperClass::getId();}
+      ETranformationType getTransformationType(void) { return TRANS_INTERPOLATE_AXIS ;}
+      static CTransformation<CAxis>* getTransformation(const StdString& id) { return SuperClass::get(id);}
+      virtual void inheritFrom(SuperTransform* srcTransform) { solveDescInheritance(true, this->SuperClass::get((MyClass*)srcTransform)) ;}
     private:
       static bool registerTrans();
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_domain.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_domain.cpp	(revision 1984)
@@ -27,5 +27,5 @@
   bool CInterpolateDomain::registerTrans()
   {
-    registerTransformation(TRANS_INTERPOLATE_DOMAIN, create);
+    registerTransformation(TRANS_INTERPOLATE_DOMAIN, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_domain.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_domain.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/interpolate_domain.hpp	(revision 1984)
@@ -41,4 +41,6 @@
       typedef CObjectTemplate<CInterpolateDomain> SuperClass;
       typedef CInterpolateDomainAttributes SuperClassAttribute;
+      typedef CInterpolateDomain MyClass ;
+      typedef CTransformation<CDomain> SuperTransform ;
 
     public :
@@ -56,4 +58,8 @@
       static StdString GetDefName(void);
       static ENodeType GetType(void);
+      const string& getId(void) { return this->SuperClass::getId();}
+      ETranformationType getTransformationType(void) { return TRANS_INTERPOLATE_DOMAIN ;}
+      static CTransformation<CDomain>* getTransformation(const StdString& id) { return SuperClass::get(id);}
+      virtual void inheritFrom(SuperTransform* srcTransform) { solveDescInheritance(true, this->SuperClass::get((MyClass*)srcTransform)) ;}
     private:
       static bool registerTrans();
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/inverse_axis.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/inverse_axis.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/inverse_axis.cpp	(revision 1984)
@@ -26,5 +26,5 @@
   bool CInverseAxis::registerTrans()
   {
-    return registerTransformation(TRANS_INVERSE_AXIS, CInverseAxis::create);
+    return registerTransformation(TRANS_INVERSE_AXIS, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/inverse_axis.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/inverse_axis.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/inverse_axis.hpp	(revision 1984)
@@ -39,4 +39,6 @@
       typedef CObjectTemplate<CInverseAxis> SuperClass;
       typedef CInverseAxisAttributes SuperClassAttribute;
+      typedef CInverseAxis MyClass ;
+      typedef CTransformation<CAxis> SuperTransform ;
 
     public :
@@ -54,5 +56,8 @@
       static StdString GetDefName(void);
       static ENodeType GetType(void);
-
+      const string& getId(void) { return this->SuperClass::getId();}
+      ETranformationType getTransformationType(void) { return TRANS_INVERSE_AXIS ;}
+      static CTransformation<CAxis>* getTransformation(const StdString& id) { return SuperClass::get(id);}
+      virtual void inheritFrom(SuperTransform* srcTransform) { solveDescInheritance(true, this->SuperClass::get((MyClass*)srcTransform)) ;}
     private:
       static bool registerTrans();
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_axis.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_axis.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_axis.cpp	(revision 1984)
@@ -27,5 +27,5 @@
   bool CReduceAxisToAxis::registerTrans()
   {
-    return registerTransformation(TRANS_REDUCE_AXIS_TO_AXIS, CReduceAxisToAxis::create);
+    return registerTransformation(TRANS_REDUCE_AXIS_TO_AXIS, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_axis.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_axis.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_axis.hpp	(revision 1984)
@@ -40,4 +40,6 @@
       typedef CObjectTemplate<CReduceAxisToAxis> SuperClass;
       typedef CReduceAxisToAxisAttributes SuperClassAttribute;
+      typedef CReduceAxisToAxis MyClass ;
+      typedef CTransformation<CAxis> SuperTransform ;
 
     public :
@@ -55,4 +57,8 @@
       static StdString GetDefName(void);
       static ENodeType GetType(void);
+      const string& getId(void) { return this->SuperClass::getId();}
+      ETranformationType getTransformationType(void) { return TRANS_REDUCE_AXIS_TO_AXIS ;}
+      static CTransformation<CAxis>* getTransformation(const StdString& id) { return SuperClass::get(id);}
+      virtual void inheritFrom(SuperTransform* srcTransform) { solveDescInheritance(true, this->SuperClass::get((MyClass*)srcTransform)) ;}
     private:
       static bool registerTrans();
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_scalar.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_scalar.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_scalar.cpp	(revision 1984)
@@ -26,5 +26,5 @@
   bool CReduceAxisToScalar::registerTrans()
   {
-    return registerTransformation(TRANS_REDUCE_AXIS_TO_SCALAR, CReduceAxisToScalar::create);
+    return registerTransformation(TRANS_REDUCE_AXIS_TO_SCALAR, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_scalar.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_scalar.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_axis_to_scalar.hpp	(revision 1984)
@@ -40,4 +40,6 @@
       typedef CObjectTemplate<CReduceAxisToScalar> SuperClass;
       typedef CReduceAxisToScalarAttributes SuperClassAttribute;
+      typedef CReduceAxisToScalar MyClass ;
+      typedef CTransformation<CScalar> SuperTransform ;
 
     public :
@@ -55,4 +57,8 @@
       static StdString GetDefName(void);
       static ENodeType GetType(void);
+      const string& getId(void) { return this->SuperClass::getId();}
+      ETranformationType getTransformationType(void) { return TRANS_REDUCE_AXIS_TO_SCALAR ;}
+      static CTransformation<CScalar>* getTransformation(const StdString& id) { return SuperClass::get(id);}
+      virtual void inheritFrom(SuperTransform* srcTransform) { solveDescInheritance(true, this->SuperClass::get((MyClass*)srcTransform)) ;}
     private:
       static bool registerTrans();
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_axis.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_axis.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_axis.cpp	(revision 1984)
@@ -28,5 +28,5 @@
   bool CReduceDomainToAxis::registerTrans()
   {
-    return registerTransformation(TRANS_REDUCE_DOMAIN_TO_AXIS, CReduceDomainToAxis::create);
+    return registerTransformation(TRANS_REDUCE_DOMAIN_TO_AXIS, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_axis.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_axis.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_axis.hpp	(revision 1984)
@@ -41,4 +41,6 @@
       typedef CObjectTemplate<CReduceDomainToAxis> SuperClass;
       typedef CReduceDomainToAxisAttributes SuperClassAttribute;
+      typedef CReduceDomainToAxis MyClass ;
+     typedef CTransformation<CAxis> SuperTransform ;
 
     public :
@@ -56,5 +58,9 @@
       static StdString GetDefName(void);
       static ENodeType GetType(void);
-    private:
+      const string& getId(void) { return this->SuperClass::getId();}
+      ETranformationType getTransformationType(void) { return TRANS_REDUCE_DOMAIN_TO_AXIS ;}
+      static CTransformation<CAxis>* getTransformation(const StdString& id) { return SuperClass::get(id);}
+      virtual void inheritFrom(SuperTransform* srcTransform) { solveDescInheritance(true, this->SuperClass::get((MyClass*)srcTransform)) ;}
+     private:
       static bool registerTrans();
       static CTransformation<CAxis>* create(const StdString& id, xml::CXMLNode* node);
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_scalar.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_scalar.cpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_scalar.cpp	(revision 1984)
@@ -26,5 +26,5 @@
   bool CReduceDomainToScalar::registerTrans()
   {
-    return registerTransformation(TRANS_REDUCE_DOMAIN_TO_SCALAR, CReduceDomainToScalar::create);
+    return registerTransformation(TRANS_REDUCE_DOMAIN_TO_SCALAR, {create, getTransformation});
   }
 
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_scalar.hpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_scalar.hpp	(revision 1975)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/reduce_domain_to_scalar.hpp	(revision 1984)
@@ -41,4 +41,6 @@
       typedef CObjectTemplate<CReduceDomainToScalar> SuperClass;
       typedef CReduceDomainToScalarAttributes SuperClassAttribute;
+      typedef CReduceDomainToScalar MyClass ;
+      typedef CTransformation<CScalar> SuperTransform ;
 
     public :
@@ -56,4 +58,8 @@
       static StdString GetDefName(void);
       static ENodeType GetType(void);
+      const string& getId(void) { return this->SuperClass::getId();}
+      ETranformationType getTransformationType(void) { return TRANS_REDUCE_DOMAIN_TO_SCALAR ;}
+      static CTransformation<CScalar>* getTransformation(const StdString& id) { return SuperClass::get(id);}
+      virtual void inheritFrom(SuperTransform* srcTransform) { solveDescInheritance(true, this->SuperClass::get((MyClass*)srcTransform)) ;}
     private:
       static bool registerTrans();
